﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Linq;

namespace Telerik.Windows.QuickStart
{
	public static class ApplicationCache
	{
		private static IDictionary<string, string> AppCache { get; set; }

		static ApplicationCache()
		{
			AppCache = new Dictionary<string, string>();
		}

		public static object LoadTypeFromCache(string type)
		{
			//string assemblyName = ApplicationHelper.CurrentLoadedAssemblyName;

			Type searchType = Type.GetType(ApplicationHelper.ApplicationType.AssemblyQualifiedName.Replace(ApplicationHelper.ApplicationType.FullName, type));

			if (searchType == null)
			{
				foreach (KeyValuePair<string, string> keyValuePair in AppCache)
				{
					//if (string.Equals(keyValuePair.Value, assemblyName, StringComparison.OrdinalIgnoreCase))
					//{
					searchType = Type.GetType(string.Format("{0},{1}", type, keyValuePair.Key));
					if (null != searchType) break;
					//}
				}
			}
			return searchType == null ? searchType : Activator.CreateInstance(searchType);
		}

		public static void SaveAssemblyInCache(Assembly assembly)
		{
			if (!AppCache.Keys.Contains(assembly.FullName))
			{
				AppCache.Add(assembly.FullName, assembly.FullName.Split(',')[0]);
			}
		}

		public static bool IsLoadedAssembly(string value)
		{
#if WPF
			return true;
#else
			bool exist =
				AppCache.Any(keyPair => string.Equals(keyPair.Value, value, StringComparison.OrdinalIgnoreCase));

			return exist;

			//foreach (KeyValuePair<string, string> keyValuePair in AppCache)
			//{
			//    if (string.Equals(keyValuePair.Value, value, StringComparison.OrdinalIgnoreCase))
			//    {
			//        return true;
			//    }
			//}
			//return false;
#endif
		}
	}
}
