﻿using System;
using System.IO;
using System.Windows;
using System.Windows.Markup;
using System.Windows.Resources;

namespace Telerik.Windows.QuickStart.Common
{
    internal class Utils
    {
        public static Style GetSpecificStyle(string styleKey, string url)
        {
            ResourceDictionary resourceDictionary = GetResourceDictionary(url);
            if (resourceDictionary.Contains(styleKey))
            {
                return resourceDictionary[styleKey] as Style;
            }

            return new Style();
        }

        public static ResourceDictionary GetResourceDictionary(string url)
        {
            Uri uri = new Uri(url, UriKind.Relative);
#if WPF
            return Application.LoadComponent(uri) as ResourceDictionary;
#else
            StreamResourceInfo info = Application.GetResourceStream(uri);
            if (info != null && info.Stream != null)
            {
                using (StreamReader reader = new StreamReader(info.Stream))
                {
                    string content = reader.ReadToEnd();
                    return XamlReader.Load(content) as ResourceDictionary;
                }
            }
			return null;
#endif
        }
    }
}
