﻿using System;
using System.Windows.Controls;
using System.Windows.Input;

namespace Telerik.Windows.QuickStart
{
	public class CustomScrollViewer : ScrollViewer
	{
		public CustomScrollViewer()
		{
			this.PreviewMouseWheel += new MouseWheelEventHandler(OnScrollViewerPreviewMouseWheel);
		}

		private void OnScrollViewerPreviewMouseWheel(object sender, MouseWheelEventArgs args)
		{
			ScrollViewer scrollViewer = sender as ScrollViewer;
			if (scrollViewer == null)
			{
				return;
			}

			double scrollDelta = Math.Abs(args.Delta * 40 / 3);

			double newOffset = 0;
			if (args.Delta > 0)
			{
				newOffset = Math.Max(0, scrollViewer.VerticalOffset - scrollDelta);
			}
			else
			{
				newOffset = Math.Min(scrollViewer.ScrollableHeight, scrollViewer.VerticalOffset + scrollDelta);
			}

			if (newOffset != scrollViewer.VerticalOffset)
			{
				scrollViewer.ScrollToVerticalOffset(newOffset);

				args.Handled = true;
			}
		}
	}
}
