﻿using System;
using Telerik.Windows.Controls;
using System.Collections.Generic;
using System.Windows.Shapes;
using System.Windows.Media;
using System.Windows.Controls;
using System.Diagnostics;
using Telerik.Windows.QuickStart.Animation;
#if WPF
using RadFrame = System.Windows.Controls.Frame;
#endif

namespace Telerik.Windows.QuickStart
{
	public static class ExtensionMethods
	{
		[System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011:ConsiderPassingBaseTypesAsParameters", Justification = "WPF compatibility")]
		public static void NavigateToExample(this RadFrame exampleContainer, BasePage page)
		{
#if WPF
			ExamplePage currentPage = exampleContainer.NavigationService.Content as ExamplePage;

			NavigationAnimator navigation = new NavigationAnimator();
			navigation.Navigate(exampleContainer, page);
			navigation.TransitionAnimationCompleted += OnTransitionAnimationCompleted;
#else
			NavigationService service = NavigationService.GetNavigationService();

			var mask1 = new Rectangle()
			{
				Fill = new SolidColorBrush(Color.FromArgb(77, 8, 17, 48))
			};
            
			var mask2 = new Rectangle()
			{
				Fill = new SolidColorBrush(Color.FromArgb(77, 8, 17, 48))
			};
			var grid = service.RootPanel as Grid;

			ExamplePage currentPage = service.RootPanel.Children[0] as ExamplePage;
			ExampleTransition exampleTransition = new ExampleTransition(grid.ActualWidth, grid, mask1, mask2);
			service.Transition = exampleTransition;
			exampleTransition.TransitionAnimationCompleted += OnTransitionAnimationCompleted;
			
			exampleContainer.Navigate(page, service.Transition);
#endif
			if (currentPage != null)
			{
				currentPage.SelectedExample.Unload();
				currentPage.SelectedExample.StartTransitionAnimation();
			}
		}

		private static void OnTransitionAnimationCompleted(object sender, TransitionEventArgs e)
		{
			var transition = sender as ExampleTransition;
			transition.TransitionAnimationCompleted -= OnTransitionAnimationCompleted;

			if (e.TargetExamplePage != null && e.TargetExamplePage is BasePage)
			{
				var examplePage = e.TargetExamplePage as BasePage;
				examplePage.SelectedExample.AnimationCompleted();
			}
		}

		public static bool Contains(this Dictionary<string, object> source, string key)
		{
			return source.ContainsKey(key);
		}
	}
}
