﻿using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;

namespace Telerik.Windows.QuickStart
{
    public class ProductPage : ContentControl
#if !WPF
        ,IFrame
#endif
    {
        public ProductPage()
        {
            this.Loaded += this.ProductPage_Loaded;
        }

        private void ProductPage_Loaded(object sender, RoutedEventArgs e)
        {
            this.ParentFrame = this.Parent as UIElement;
        }

        private string hash = "";

        public string Path
        {
            get
            {
                return this.GetType().FullName;
            }
        }

        public string Hash
        {
            get
            {
                if (string.IsNullOrEmpty(this.hash))
                {
                    return this.Path;
                }
                return this.hash;
            }
            set
            {
                this.hash = value;
            }
        }

        public string Url
        {
            get
            {
                return this.GetType().FullName;
            }
            set
            {
            }
        }

        public virtual UIElement ParentFrame
        {
            get;
            set;
        }

        public string Title
        {
            get;
            set;
        }

        public bool IsAdded
        {
            get;
            set;
        }

        public void SetContent(UserControl content)
        {
            Content = content;
        }
    }
}
